#include <iostream>
#include <algorithm>
#include <cstring>

using namespace std;

const int MAXN = 10000;
const int SIGMA = 26;

int n, plen[2*MAXN+5], dp[MAXN+3];
char s[2*MAXN+5];

void padString()
{
	for (int i = n; i >= 1; i--) {
		s[2*i+1] = '*';
		s[2*i] = s[i];
	}
	s[1] = '*';
	s[0] = '$';
}

void manacher()
{
	int best = 1;
	for (int i = 2; i <= 2*n+1; i++) {
		if (i <= best + plen[best]) {
			plen[i] = min(plen[2*best-i], best + plen[best] - i);
		}
		while (s[i+plen[i]+1] == s[i-plen[i]-1]) {
			plen[i]++;
		}
		if (i + plen[i] > best + plen[best]) {
			best = i;
		}
	}
}

void calcDp()
{
	dp[1] = 1;
	for (int i = 2; i <= n; i++) {
		dp[i] = dp[i-1] + 1;
		for (int j = i-1; j >= 1; j--) {
			if (plen[i+j] >= i-j) {
				dp[i] = min(dp[i], dp[j-1] + 1);
			}
		}
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	cin >> (s+1);
	n = strlen(s+1);
	padString();
	manacher();
	calcDp();
	cout << dp[n];
	return 0;
}
