#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <string>
#include <bitset>

const int NMAX = 1e4;

std::bitset<NMAX> isPal[NMAX];
int dp[NMAX];

int main() {
  #ifdef LOCAL
freopen("input.txt", "r", stdin);
  #endif
  std::string s;
  std::cin >> s;
  
  int n = (int) s.size();
  for (int l = n - 1; l >= 0; l--) {
    isPal[l][l] = true;
    isPal[l][l + 1] = (s[l] == s[l + 1]);
    for (int r = l + 2; r < n; r++) {
      isPal[l][r] = isPal[l + 1][r - 1] & (s[l] == s[r]);
    }
  }

  for (int i = 0; i < n; i++) {
    dp[i] = i + 1;
    if (isPal[0][i]) {
      dp[i] = 1;
    }
    for (int j = i; j > 0; j--) {
      if (isPal[j][i]) {
        dp[i] = std::min(dp[i], dp[j - 1] + 1);
      }
    }
  }

  std::cout << dp[n - 1];

  return 0;
}