#include <iostream>

using namespace std;

constexpr int LIM = 1e4;
constexpr int INF = 1e9;
using ull = unsigned long long;
constexpr ull P = 37;

string str;
int N, dp[LIM + 1];
ull h[LIM + 1], hrev[LIM + 1], p[LIM + 1];

ull chash(int l, int r, ull hsh[]) {
    return hsh[r] - hsh[l - 1] * p[r - l + 1];
}

bool is_palindrome(int l, int r) {
    return chash(l, r, h) == chash(N - r + 1, N - l + 1, hrev);
}

int main() {
    cin >> str;
    N = str.size();

    p[0] = 1;
    for (int i = 1; i <= N; ++i) {
        h[i] = h[i - 1] * P + str[i - 1] - 'a' + 1;
        hrev[i] = hrev[i - 1] * P + str[N - i] - 'a' + 1;
        p[i] = p[i - 1] * P;
    }

    for (int i = 1; i <= N; ++i) {
        dp[i] = INF;
        for (int j = i; j >= 1; --j)
            if (is_palindrome(j, i)) {
                dp[i] = min(dp[i], 1 + dp[j - 1]);
            }
    }

    cout << dp[N];
    return 0;
}
