#include <iostream>
#include <vector>
#include <queue>

constexpr int INF = 1e9;

int main() {
	std::string str;
	std::cin >> str;

	int n = (int)str.size();
	std::vector<std::vector<int>> fwd(n + 1);
	for( int center = 0; center < n; center++ ){
		int r = 0;
		while( center - r >= 0 && str[center - r] == str[center + r] ){
			fwd[center - r].push_back( center + r + 1 );
			r++;
		}
	}

	for( int center = 1; center < n; center++ ){
		int r = 0;
		while( center - 1 - r >= 0 && str[center - 1 - r] == str[center + r] ){
			fwd[center - 1 - r].push_back( center + r + 1 );
			r++;
		}
	}

	std::vector<int> dist(n + 1, +INF);
	std::queue<int> q({0});
	dist[0] = 0;

	while( !q.empty() ){
		int u = q.front();
		q.pop();

		for( int v : fwd[u] )
			if( dist[u] + 1 < dist[v] ){
				dist[v] = 1 + dist[u];
				q.push( v );
			}
	}

	std::cout << dist[n] << std::endl;
	return 0;
}