#include <iostream>
#include <string>

std::string zero_pad(std::string a, int len) {
    while (a.length() < len) {
        a = "0" + a;
    }
    return a;
}

std::string add_nums(std::string a, std::string b) {
    int len = std::max(a.length(), b.length());
    a = zero_pad(a, len);
    b = zero_pad(b, len);

    std::string res = zero_pad("", len);
    int carry = 0;

    for (int i = a.size() - 1; i >= 0; i--) {
        int temp = a[i] - '0' + b[i] - '0' + carry;
        res[i] = temp % 10 + '0';
        carry = temp >= 10;
    }
    if (carry) {
        return "1" + res;
    }

    return res;
}

signed main() {
    std::string a, b;
    std::cin >> a >> b;
    std::cout << add_nums(a, b);
}
