#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n;
int dp[MAXN];
int maxEven[MAXN];
int maxOdd[MAXN];
std::string s;

void solve()
{
    for (int j = 0 ; j < n ; ++j)
    {
        for (int i = 1 ; j - i >= 0 && j + i < n ; ++i)
        {
            if (s[j - i] != s[j + i])
            {
                break;
            }

            maxOdd[j]++;
        }
    }

    for (int j = 0 ; j < n ; ++j)
    {
        for (int i = 0 ; j - i >= 0 && j + i + 1 < n ; ++i)
        {
            if (s[j - i] != s[j + i + 1])
            {
                break;
            }

            maxEven[j]++;
        }
    }

    for (int i = n - 1 ; i >= 0 ; --i)
    {
        dp[i] = dp[i + 1] + 1;
        for (int j = i + 1 ; j < n ; ++j)
        {
            if ((j - i + 1) % 2 == 1)
            {
                int mid = (i + j) / 2;
                // std::cout << "here: " << i << ' ' << j << ' ' << mid << ' ' << maxOdd[mid] << '\n';
                if (mid - i <= maxOdd[mid])
                {
                    dp[i] = std::min(dp[i], dp[mid + (mid - i) + 1] + 1);
                }
            }
            
            if ((j - i + 1) % 2 == 0)
            {
                int mid = (i + j - 1) / 2;
                if (mid - i < maxEven[mid])
                {
                    dp[i] = std::min(dp[i], dp[mid + (mid - i + 1) + 1] + 1);
                }
            }
        }

        // std::cout << "dp: " << i << " = " << dp[i] << '\n';
    }

    std::cout << dp[0] << '\n';
}

void input()
{
    std::cin >> s;
    n = s.size();
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}