#include "absent.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXLOG = 10;

int currCnt[2];
int cnt[MAXLOG][2];
void play(int n)
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 0 ; j < MAXLOG ; ++j)
        {
            cnt[j][((i & (1 << j)) > 0)]++;
        }
    }

    int answer = 0;
    std::vector <std::pair <int,int>> candidates;
    for (int i = 1 ; i < n ; ++i)
    {
        candidates.push_back({i, 0});
    }

    int l = 1, r = n;
    for (int j = MAXLOG - 1 ; j >= 0 && l != r ; --j)
    {
        int mid = l;
        while (!(((mid + 1) & (1 << j))) && mid + 1 <= r)
        {
            mid++;
        }

        currCnt[0] = currCnt[1] = 0;
        for (int i = 0 ; i < candidates.size() ; ++i)
        {
            candidates[i].second = get_bit(candidates[i].first, MAXLOG - j);
            currCnt[candidates[i].second]++;
        }

        if (currCnt[0] == cnt[j][0])
        {
            for (int i = l ; i <= mid ; ++i)
            {
                for (int k = 0 ; k < MAXLOG ; ++k)
                {
                    cnt[k][((i & (1 << k)) > 0)]--;
                }
            }

            l = mid + 1;
            std::vector <std::pair <int,int>> newCandidates;
            for (const auto &x : candidates)
            {
                if (x.second == 1)
                {
                    newCandidates.push_back(x);
                }
            }

            candidates = newCandidates;
        } else
        {
            for (int i = mid + 1 ; i <= r ; ++i)
            {
                for (int k = 0 ; k < MAXLOG ; ++k)
                {
                    cnt[k][((i & (1 << k)) > 0)]--;
                }
            }

            r = mid;
            std::vector <std::pair <int,int>> newCandidates;
            for (const auto &x : candidates)
            {
                if (x.second == 0)
                {
                    newCandidates.push_back(x);
                }
            }

            candidates = newCandidates;
        }
    }

    submit_absent(l);
}