#include<iostream>
#include<string>
#include<algorithm>
#define endl '\n'

using namespace std;

const int MAXN=1e4+5;
const int B=137;
const int MOD=1e9+7;

string s;
int n;
int dp[MAXN];
long long pwr[MAXN];
long long h[MAXN];
long long revH[MAXN];

void calcHash()
{
    pwr[0]=1;
    for(int i=1;i<=n;i++) pwr[i]=pwr[i-1]*B%MOD;

    h[0]=0;
    for(int i=1;i<=n;i++)
    {
        h[i]=(h[i-1]*B+s[i-1])%MOD;
    }
    reverse(s.begin(), s.end());
    
    revH[0]=0;
    for(int i=1;i<=n;i++)
    {
        revH[i]=(revH[i-1]*B+s[i-1])%MOD;
    }
}

int getH(int l,int r)
{
    return (h[r]-h[l-1]*pwr[r-l+1]%MOD+MOD)%MOD;
}

int getRevH(int l,int r)
{
    return (revH[r]-revH[l-1]*pwr[r-l+1]%MOD+MOD)%MOD;
}

bool isPal(int l,int r)
{
    int revL=n-r+1;
    int revR=n-l+1;
    if(getH(l,r)==getRevH(revL,revR)) return 1;
    return 0;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>s;
    n=s.size();

    calcHash();
    dp[0]=0;
    for(int i=1;i<=n;i++)
    {
        dp[i]=1e9;
        for(int j=1;j<=i;j++)
        {
            if(isPal(j,i)) dp[i]=min(dp[i], dp[j-1]+1);
        }
    }

    cout<<dp[n]<<endl;

    return 0;
}